// -*- mode: c++ -*-
// $Id: dualviewer.h,v 1.8 2000/08/08 21:28:16 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/dualviewer.h,v $

#ifndef __DUALVIEWER_H__
#define __DUALVIEWER_H__

#include "camera.h"
#include "arcball.h"
#include "viewer.h"

class OcTree;

class DualViewer : public Viewer {

public:
  DualViewer(int width = 300, int height = 300);
  virtual ~DualViewer() { _dualmesh = 0; };

  void setDualMesh(OcTree *t) { _dualmesh = t; };

  void setCameraPosition(const cvec3d& pos);

private:
  // window parameters
  int meshNumber;
  // mouse button down state
  bool buttonDown;

  // dual mesh
  OcTree *_dualmesh;
  // camera plane
  cvec3d _planeNormal[8];
  double _planeD[8];

  // camera
  Camera _camera;
  // arcball
  ArcBall _arcball;

  void setClipping();
  void disableClipping();
  void render();

  void display();
  void reshape(int w, int h);
  void mouse(int button, int state, int x, int y);
  void motion(int x, int y);
};

#endif /* __DUALVIEWER_H__ */
