// -*- mode: c++ -*-
// $Id: meshviewer.h,v 1.6 2000/07/21 01:33:17 jianbo Exp $
// $Source: /tools/cvs-repos/illustrate/src/meshviewer.h,v $

#ifndef __MESHVIEWER_H__
#define __MESHVIEWER_H__

#include "camera.h"
#include "arcball.h"
#include "uiaction.h"
#include "subtri.h"
#include "tagmesh.h"
#include "grid3d.h"
#include "viewer.h"

class Silhouettes;

class MeshViewer : public Viewer {

public:
  MeshViewer(const Camera &c, ArcBall *b, Grid3D *g, Silhouettes *s,
	     int width = 400, int height = 300);
  virtual ~MeshViewer();

  Camera& camera() { return _camera; };

  void setMesh(TMesh *m) { _mesh = m; };
  void clearDisplayList();

private:
  // camera
  Camera _camera;

  // arcball
  ArcBall *_arcball;

  // 3D grid
  Grid3D *_grid;

  // triangle mesh
  TMesh *_mesh;

  // silhouette
  Silhouettes *_sil;

  // zoom
  bool _zooming;
  int _zoomY;

  // translate
  bool _translating;
  int _transX, _transY;

  // display list
  int _renderList;

  // UI action
  UiAction *_uiAction;

  void setLight();
  void setLightAndMaterial();
  void render();

  void display();
  void reshape(int w, int h);
  void mouse(int button, int state, int x, int y);
  void motion(int x, int y);
};

#endif /* __MESHVIEWER_H__ */

