##############################################
# Compiler and application sources
##############################################
CC = CC
cc = cc

AR = ar csr $@

#Lib name
LIBTARGET = libsub.a

#Source files (with header)
SOURCES	= arcball.cpp camera.cpp flatmesh.cpp ivgraph.cpp \
	subtri.cpp tagflatmesh.cpp tagivgraph.cpp trirule.cpp

#Source files without header
SRC_NOH =

#All source files
ALLSRCS = $(SOURCES) $(SRC_NOH)

#All header files
HEADERS = ${SOURCES:.cpp=.h}

#All object files
#OBJDIR = OBJS
OBJS = ${ALLSRCS:.cpp=.o}
LIBOBJS = ${SOURCES:.cpp=.o}

#include directories
INCLUDES = -I../qvlib/include -I../include

#other options
#OPTIONS = -g -ptused
OPTIONS = -DNDEBUG -O2 -ptused
CCOPTS = -OPT:Olimit=5000 -n32 -woff 1174 -MDupdate $(DEP)

#libs and lib directories
LIBS = -L../qvlib/src -lqv -lglut -lGL -lGLU -lX11 -lXmu -lm

#dependencies
DEPOPTS = -M
DEP = Makedepend

CCFLAGS = $(INCLUDES) $(OPTIONS) $(CCOPTS)
LNKFLAGS = $(OPTIONS) $(LIBS)

##############################################
# Default rules
##############################################

.SUFFIXES : .cpp .o

.cpp :
	$(CC) $(CCFLAGS) -o $@ $<

.cpp.o :
	$(CC) $(CCFLAGS) -o $@ -c $<

##############################################
# Application-specific rules and dependencies
##############################################

$(LIBTARGET) :	$(LIBOBJS)
	$(AR) $(LIBOBJS)

depend :	$(ALLSRCS)
	$(CC) $(INCLUDES) $(DEPOPTS) $(ALLSRCS) > $(DEP)

clean :
	@rm -f $(TARGET) $(LIBTARGET) $(OBJS) core ii_files/* $(DEP)

#include dependencies
sinclude $(DEP)
